searchData={"items":[{"type":"task","title":"mix factory_ex.gen","doc":"This can be used to generate factories for usage with ecto `--repo` is required\n\n#","ref":"Mix.Tasks.FactoryEx.Gen.html"},{"type":"task","title":"Example - mix factory_ex.gen","doc":"```bash\n$ mix factory_ex.gen --repo MyApp.Repo MyApp.Accounts.User\n$ mix factory_ex.gen --repo MyApp.Repo MyApp.Accounts.User MyApp.Accounts.Role\n```\n\n#","ref":"Mix.Tasks.FactoryEx.Gen.html#module-example"},{"type":"task","title":"Options - mix factory_ex.gen","doc":"- `dirname` - Set directory name to generate into `../my_app/test/support/factory/`\n- `force` - Force create files, no confirmations\n- `quiet` - No output messages","ref":"Mix.Tasks.FactoryEx.Gen.html#module-options"},{"type":"function","title":"Mix.Tasks.FactoryEx.Gen.ensure_schema_counter_start_added/1","doc":"","ref":"Mix.Tasks.FactoryEx.Gen.html#ensure_schema_counter_start_added/1"},{"type":"function","title":"Mix.Tasks.FactoryEx.Gen.generate_factory/3","doc":"","ref":"Mix.Tasks.FactoryEx.Gen.html#generate_factory/3"},{"type":"function","title":"Mix.Tasks.FactoryEx.Gen.matching_faker_functions/1","doc":"","ref":"Mix.Tasks.FactoryEx.Gen.html#matching_faker_functions/1"},{"type":"function","title":"Mix.Tasks.FactoryEx.Gen.run/1","doc":"","ref":"Mix.Tasks.FactoryEx.Gen.html#run/1"},{"type":"behaviour","title":"FactoryEx","doc":"# FactoryEx\n[![Coverage](https://github.com/theblitzapp/factory_ex/actions/workflows/coverage.yml/badge.svg)](https://github.com/theblitzapp/factory_ex/actions/workflows/coverage.yml)\n[![Test](https://github.com/theblitzapp/factory_ex/actions/workflows/test.yml/badge.svg)](https://github.com/theblitzapp/factory_ex/actions/workflows/test.yml)\n[![Dialyzer](https://github.com/theblitzapp/factory_ex/actions/workflows/dialyzer.yml/badge.svg)](https://github.com/theblitzapp/factory_ex/actions/workflows/dialyzer.yml)\n[![Credo](https://github.com/theblitzapp/factory_ex/actions/workflows/credo.yml/badge.svg)](https://github.com/theblitzapp/factory_ex/actions/workflows/credo.yml)\n[![codecov](https://codecov.io/gh/theblitzapp/factory_ex/branch/master/graph/badge.svg?token=V0JJA5AZ1H)](https://codecov.io/gh/theblitzapp/factory_ex)\n[![Hex version badge](https://img.shields.io/hexpm/v/factory_ex.svg)](https://hex.pm/packages/factory_ex)\n\n#","ref":"FactoryEx.html"},{"type":"behaviour","title":"Installation - FactoryEx","doc":"[Available in Hex](https://hex.pm/packages/factory_ex), the package can be installed\nby adding `factory_ex` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:factory_ex, \"~> 0.1.0\"}\n  ]\nend\n```\n\nDocumentation can be found at  .\n\n#","ref":"FactoryEx.html#module-installation"},{"type":"behaviour","title":"Using - FactoryEx","doc":"For defining your own factories just implement `schema/0`, `repo/0` and\n`build/0` callback e.g:\n\n```elixir\ndefmodule MyFactory do\n  @behaviour FactoryEx\n\n  def schema, do: MySchema\n\n  def repo, do: MyRepo\n\n  def build(params \\\\ %{}) do\n    default = %{\n      foo: 21,\n      bar: 42\n    }\n\n    Map.merge(default, params)\n  end\nend\n```\n\nAnd then using it in your tests as:\n\n```elixir\n# For getting a default parameter struct.\nFactoryEx.build(MyFactory)\n\n# For getting a default parameter struct with a modification.\nFactoryEx.build(MyFactory, foo: 42)\n\n# For getting a default parameter struct and not validating the changeset\nFactoryEx.build(MyFactory, [foo: 42], validate?: false)\n\n# For getting a default parameter map.\nFactoryEx.build_params(MyFactory)\n\n# For getting a default parameter map with a modification..\nFactoryEx.build_params(MyFactory, foo: 10)\n\n# For getting a default parameter map and not validating the changeset\nFactoryEx.build_params(MyFactory, foo: 10, validate?: false)\n\n# For getting multiple default parameter maps\nFactoryEx.build_many_params(MyFactory, [foo: 42])\n\n# For getting an invalid parameter maps\nFactoryEx.build_invalid_params(MyFactory, [foo: 42])\n\n# For inserting a default schema.\nFactoryEx.insert!(MyFactory)\n\n# For inserting a default schema with a modification.\nFactoryEx.insert!(MyFactory, foo: 42)\n\n# For inserting multiple default schema\nFactoryEx.insert_many!(10, MyFactory, foo: 42)\n```\n\n#","ref":"FactoryEx.html#module-using"},{"type":"behaviour","title":"Using FactoryEx.SchemaCounter - FactoryEx","doc":"In order to avoid duplicate data on fields and guarentee unique data, we can use\n`FactoryEx.SchemaCounter` to generate unique integers to append to our fields.\n\nFor example our factory could look like the following:\n\n```elixir\ndefmodule MyFactory do\n  @behaviour FactoryEx\n\n  def schema, do: MySchema\n\n  def repo, do: MyRepo\n\n  def build(params \\\\ %{}) do\n    default = %{\n      foo: FactoryEx.SchemaCounter.next(\"my_factory_foo\"),\n      bar: FactoryEx.SchemaCounter.next(\"my_factory_bar\")\n    }\n\n    Map.merge(default, params)\n  end\nend\n```\n\nTo utilize `FactoryEx.SchemaCounter`, we must call `FactoryEx.SchemaCounter.start()` in the `test/test_helper.exs` file.\n\n#","ref":"FactoryEx.html#module-using-factoryex-schemacounter"},{"type":"behaviour","title":"Generating Factories - FactoryEx","doc":"FactoryEx comes with a helpful mix command to generate factories into our application\n\n```bash\n$ mix factory_ex.gen --repo FactoryEx.Support.Repo FactoryEx.Support.Accounts.User\n$ mix factory_ex.gen --repo FactoryEx.Support.Repo FactoryEx.Support.{Accounts.{User,Role},Authentication.{Token,Session}}\n```\n\nTo read more info run `mix factory_ex.gen`\n\n\n#","ref":"FactoryEx.html#module-generating-factories"},{"type":"behaviour","title":"FactoryEx.build options - FactoryEx","doc":"We can also specify options to `&FactoryEx.build/3`\n\n* `:keys` - Sets the type of keys to have in the built object, can be one of `:atom`, `:string` or `:camel_string`","ref":"FactoryEx.html#module-factoryex-build-options"},{"type":"callback","title":"FactoryEx.build/1","doc":"Callback that returns a map with valid defaults for the schema.","ref":"FactoryEx.html#c:build/1"},{"type":"function","title":"FactoryEx.build/3","doc":"Builds a schema given the factory `module` and an optional\nlist/map of `params`.","ref":"FactoryEx.html#build/3"},{"type":"function","title":"FactoryEx.build_invalid_params/1","doc":"","ref":"FactoryEx.html#build_invalid_params/1"},{"type":"function","title":"FactoryEx.build_many_params/4","doc":"Builds many parameters for a schema `changeset/2` function given the factory\n`module` and an optional list/map of `params`.","ref":"FactoryEx.html#build_many_params/4"},{"type":"function","title":"FactoryEx.build_params/3","doc":"Builds the parameters for a schema `changeset/2` function given the factory\n`module` and an optional list/map of `params`.","ref":"FactoryEx.html#build_params/3"},{"type":"callback","title":"FactoryEx.build_struct/1","doc":"Callback that returns a struct with valid defaults for the schema.","ref":"FactoryEx.html#c:build_struct/1"},{"type":"function","title":"FactoryEx.cleanup/2","doc":"Removes all the instances of a schema from the database given its factory\n`module`.","ref":"FactoryEx.html#cleanup/2"},{"type":"function","title":"FactoryEx.insert!/3","doc":"Inserts a schema given the factory `module` and an optional list/map of\n`params`. Fails on error.","ref":"FactoryEx.html#insert!/3"},{"type":"function","title":"FactoryEx.insert_many!/4","doc":"Insert as many as `count` schemas given the factory `module` and an optional\nlist/map of `params`.","ref":"FactoryEx.html#insert_many!/4"},{"type":"callback","title":"FactoryEx.repo/0","doc":"Callback that returns the schema's repo module.","ref":"FactoryEx.html#c:repo/0"},{"type":"callback","title":"FactoryEx.schema/0","doc":"Callback that returns the schema module.","ref":"FactoryEx.html#c:schema/0"},{"type":"type","title":"FactoryEx.build_opts/0","doc":"","ref":"FactoryEx.html#t:build_opts/0"},{"type":"module","title":"FactoryEx.SchemaCounter","doc":"This is a counter module that wraps :counters\n\n#","ref":"FactoryEx.SchemaCounter.html"},{"type":"module","title":"Setting Up - FactoryEx.SchemaCounter","doc":"We can use this in our application by calling `FactoryEx.SchemaCounter.start()`\ninside our `test/test_helper.exs` file.\n\n#","ref":"FactoryEx.SchemaCounter.html#module-setting-up"},{"type":"module","title":"Using SchemaCounter - FactoryEx.SchemaCounter","doc":"We can then use this module to add unique integers to each field, each value\nwill only be used once provided we continue to call `FactoryEx.SchemaCounter.next`\n\n```elixir\nFactoryEx.SchemaCounter.next(\"my_schema_field\")\n```","ref":"FactoryEx.SchemaCounter.html#module-using-schemacounter"},{"type":"function","title":"FactoryEx.SchemaCounter.get/1","doc":"Gets the counter for a specific key\n\n#","ref":"FactoryEx.SchemaCounter.html#get/1"},{"type":"function","title":"Example - FactoryEx.SchemaCounter.get/1","doc":"iex> key = Enum.random(1..10_000_000)\n    iex> FactoryEx.SchemaCounter.increment(key)\n    :ok\n    iex> FactoryEx.SchemaCounter.get(key)\n    1","ref":"FactoryEx.SchemaCounter.html#get/1-example"},{"type":"function","title":"FactoryEx.SchemaCounter.increment/1","doc":"Increments the counter for a specific key\n\n#","ref":"FactoryEx.SchemaCounter.html#increment/1"},{"type":"function","title":"Example - FactoryEx.SchemaCounter.increment/1","doc":"iex> key = Enum.random(1..10_000_000)\n    iex> FactoryEx.SchemaCounter.increment(key)\n    :ok\n    iex> FactoryEx.SchemaCounter.get(key)\n    1","ref":"FactoryEx.SchemaCounter.html#increment/1-example"},{"type":"function","title":"FactoryEx.SchemaCounter.next/1","doc":"Increments and gets the current value for a specific key\n\n#","ref":"FactoryEx.SchemaCounter.html#next/1"},{"type":"function","title":"Example - FactoryEx.SchemaCounter.next/1","doc":"iex> key = Enum.random(1..10_000_000)\n    iex> FactoryEx.SchemaCounter.next(key)\n    0\n    iex> FactoryEx.SchemaCounter.next(key)\n    1\n    iex> FactoryEx.SchemaCounter.next(key)\n    2","ref":"FactoryEx.SchemaCounter.html#next/1-example"},{"type":"function","title":"FactoryEx.SchemaCounter.put/2","doc":"Puts the counter for a specific key\n\n#","ref":"FactoryEx.SchemaCounter.html#put/2"},{"type":"function","title":"Example - FactoryEx.SchemaCounter.put/2","doc":"iex> key = Enum.random(1..10_000_000)\n    iex> FactoryEx.SchemaCounter.increment(key)\n    :ok\n    iex> FactoryEx.SchemaCounter.put(key, 1234)\n    :ok\n    iex> FactoryEx.SchemaCounter.get(key)\n    1234","ref":"FactoryEx.SchemaCounter.html#put/2-example"},{"type":"function","title":"FactoryEx.SchemaCounter.start/0","doc":"This starts the SchemaCounter, you need to call this before calling any of the other\nfunctions in this module. Most commonly this will go in your `test/test_helper.exs` file","ref":"FactoryEx.SchemaCounter.html#start/0"}],"content_type":"text/markdown"}